require "./AI/USER_AI/UserHead.lua"

function	GetOwnerEnemy (myid)
	local result = 0
	local owner  = GetV (V_OWNER,myid)
	local actors = GetActors ()
	local enemys = {}
	local index = 1
	local target
	for i,v in ipairs(actors) do
		if (v ~= owner and v ~= myid) then
			target = GetV (V_TARGET,v)
			if (target == owner) then
				if (IsMonster(v) == 1) then
					enemys[index] = v
					index = index+1
				else
					local motion = GetV(V_MOTION,i)
					if (motion == MOTION_ATTACK or motion == MOTION_ATTACK2) then
						enemys[index] = v
						index = index+1
					end
				end
			end
		end
	end

	local min_dis = 100
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)
		if (dis < min_dis) then
			result = v
			min_dis = dis
		end
	end
	
	return result
end





function	GetMyEnemy (myid)
	local result = 0

	if (AIType == EIGHT_WAIT_AI) then
		result = GetMyEnemyA (myid)
	elseif (AIType == RANDOM_WAIT_AI) then
		result = GetMyEnemyB (myid)
	elseif (AIType == SHY_WAIT_AI) then
		result = 0
	end
	return result
end






-------------------------------------------
--  U^ GetMyEnemy
-------------------------------------------
function	GetMyEnemyA (myid)
	local result = 0
	local owner  = GetV (V_OWNER,myid)
	local actors = GetActors ()
	local enemys = {}
	local index = 1
	local target
	for i,v in ipairs(actors) do
		if (v ~= owner and v ~= myid) then
			target = GetV (V_TARGET,v)
			if (target == myid) then
				enemys[index] = v
				index = index+1
			end
		end
	end

	local min_dis = 100
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)
		if (dis < min_dis) then
			result = v
			min_dis = dis
		end
	end

	return result
end





-------------------------------------------
--  U^ GetMyEnemy
-------------------------------------------
function	GetMyEnemyB (myid)
	local result = 0
	local owner  = GetV (V_OWNER,myid)
	local actors = GetActors ()
	local enemys = {}
	local index = 1
	local suftarget = 0
	local type
	for i,v in ipairs(actors) do
		if (v ~= owner and v ~= myid) then
			if (1 == IsMonster(v))	then
				enemys[index] = v
				index = index+1
			end
		end
	end

	local min_dis = ATTACK_SIGHT
	local dis
	for i,v in ipairs(enemys) do
		dis = GetDistance2 (myid,v)
		if (dis < min_dis) then
			if (GetV(V_TARGET, v) == myid) then
				result = v
				min_dis = dis
				suftarget = 1
			elseif (GetV(V_TARGET,v) == 0 and suftarget == 0) then
				result = v
				min_dis = dis
			end
		end
	end
	
--	TraceAI("Auto Attac YEAH!!")
	return result
end

--------------------------------------------------------------------------------
-- XLgpm Zo SkillProbability
-- ͂SP̎gp ꕪ  XLgpx
-- xOɋ߂قǏoՂ
function	IsUseSkill (persp,occlevel)
	math.randomseed(GetTick())
	if ((math.pow(persp,occlevel) * 10000) > math.random(10000)) then
		return true
	else 
		return false
	end
end
--------------------------------------------------------------------------------



--------------------------------------------------------------------------------
-- ԃ|Cg܂ňړ
-- idWx,y܂ňړꍇ̒ԓ_܂ňړ
--
--     	z
--		
--		
--		
--		
--		
--		
--		
--		(p_zNX΂߂5}X)Ɉړ
--		(I[i[)܂ňړ

--		z
--		
--		
--		
--		
--		
--		΂߂5}XsKvȂꍇL̂悤ȈړɂȂ
function	MoveToHalfway (id,x,y)
	local MyX, MyY =  GetV(V_POSITION, id)
	local HalfX
	local HalfY
	
	if (MyX > x) then
		if ((MyX - x) > 5) then
			HalfX = x + 5
		else
			HalfX = MyX
		end
	else
		if ((x - MyX) > 5) then
			HalfX = x - 5
		else
			HalfX = MyX
		end
	end
	
	if (MyY > y) then
		if ((MyY - y) > 5) then
			HalfY = y + 5
		else
			HalfY = MyY
		end
	else
		if ((y - MyY) > 5) then
			HalfY = y - 5
		else
			HalfY = MyY
		end
	end
	
	Move(id, HalfX, HalfY)
	
	return nil
end
--------------------------------------------------------------------------------



--------------------------------------------------------------------------------
-- PlayDancing@AĨ^Cvɂđҋ@Ԃ̈ړω
-- ̎AI(EIGHT_WAIT_AI)		F̎`ړ
-- _AI(RANDOM_WAIT_AI)	FI[i[𒆐SƂa6͈̔͂_Ɉړ
-- CAI(SHY_WAIT_AI)			FI[i[𒆐S1}Xׂ̓kɈړ
function PlayDancing(myid)
	local MasX,MasY = GetV(V_POSITION, GetV(V_OWNER, myid))

	if (AIType == EIGHT_WAIT_AI) then
		DanceCount = math.mod(DanceCount,80)
		if (DanceCount == 0) then
			Move(myid, MasX+2, MasY+2)
		elseif (DanceCount == 6) then
			Move(myid, MasX-2, MasY-2)
		elseif (DanceCount == 40) then
			Move(myid, MasX-2, MasY+2)
		elseif (DanceCount == 46) then
			Move(myid, MasX+2, MasY-2)
		end
	elseif (AIType == RANDOM_WAIT_AI) then
		DanceCount = math.mod(DanceCount,45)
		math.randomseed(GetTick())
		if (DanceCount == 0) then
			Move(myid, MasX+math.random(0,12)-6, MasY+math.random(0,12)-6)
		end
	else
		DanceCount = math.mod(DanceCount,12)
		if (DanceCount == 0) then
			Move(myid, MasX+1,MasY)
		elseif (DanceCount == 3) then
			Move(myid, MasX, MasY+1)
		elseif (DanceCount == 6) then
			Move(myid, MasX-1, MasY)
		elseif (DanceCount == 9) then
			Move(myid, MasX, MasY-1)
		end
	end
	
	DanceCount = DanceCount + 1
end
--------------------------------------------------------------------------------
-- 񕜎ҋ@Ԉړ
function PlayRecoverDancing(myid)
local MasX,MasY = GetV(V_POSITION, GetV(V_OWNER, myid))

	if (AIType == EIGHT_WAIT_AI) then
		DanceCount = math.mod(DanceCount,4)
		if (DanceCount == 0) then
			Move(myid, MasX+2, MasY+2)
		elseif (DanceCount == 1) then
			Move(myid, MasX-2, MasY-2)
		elseif (DanceCount == 2) then
			Move(myid, MasX-2, MasY+2)
		elseif (DanceCount == 3) then
			Move(myid, MasX+2, MasY-2)
		end
	elseif (AIType == RANDOM_WAIT_AI) then
		math.randomseed(GetTick())
		Move(myid, MasX+math.random(0,12)-6, MasY+math.random(0,12)-6)
	else
		DanceCount = math.mod(DanceCount,4)
		if (DanceCount == 0) then
			Move(myid, MasX+1,MasY)
		elseif (DanceCount == 1) then
			Move(myid, MasX, MasY+1)
		elseif (DanceCount == 2) then
			Move(myid, MasX-1, MasY)
		elseif (DanceCount == 3) then
			Move(myid, MasX, MasY-1)
		end
	end
	
	DanceCount = DanceCount + 1
end
--------------------------------------------------------------------------------



--------------------------------------------------------------------------------
-- GetPlayer centerid狗scopẽvC[(X^[ȊOƂ܂ȃvC[TO)
-- 擾ꗗԂ
function GetPlayer(centerid,scope)
	local actors	=	GetActors()
	local player	=	{}
	local p_count 	=	0
	for i,v in ipairs(actors) do
		if(v ~= GetV(V_OWNER,MyID) and v ~= MyID) then
			if(1 ~= IsMonster(v)) then
				if(GetDistance2(v,centerid) < scope) then
					p_count = p_count + 1
					player[p_count] = v
				end
			end
		end
	end
	return player
end
--------------------------------------------------------------------------------



--------------------------------------------------------------------------------
-- IsEscape myidׂۂf
-- ̎ҋ@@_ҋ@		HPEscapeHpPersentȉ^[QbgԂőJ
-- Cҋ@						HPɊ֌WȂ^[QbgԂőJ
function IsEscape(myid)
	local actors = GetActors()
	if(AIType == SHY_WAIT_AI) then
		for i,v in ipairs(actors) do
			if (1 == IsMonster(v)) then
				if (myid == GetV(V_TARGET,v)) then
					return true
				end
			end
		end
	elseif(EscapeHpPersent > (GetV(V_HP,myid) / GetV(V_MAXHP,myid))) then
		for i,v in ipairs(actors) do
			if (1 == IsMonster(v)) then
				if (myid == GetV(V_TARGET,v)) then
					return true
				end
			end
		end
	end
	return false
end
--------------------------------------------------------------------------------



--------------------------------------------------------------------------------
-- ̎s
-- ŐڋߓGƋt̕ɓ
-- }X^߂ɖ߂܂
function RunAway(myid)
	local actors	=	GetActors()
	local monsters = {}
	local mobcount = 0
	local min_dis = ATTACK_SIGHT
	local dis
	local result = 0
	
	for i,v in ipairs(actors) do
		if(1 == IsMonster(v)) then
			if (myid == GetV(V_TARGET,v)) then
				mobcount = mobcount + 1
				monsters[mobcount] = v
			end
		end
	end
	
	for i,v in ipairs(monsters) do
		dis = GetDistance2 (myid,v)
		if (dis < min_dis) then
			result = v
			min_dis = dis
		end
	end

	if(GetDistanceFromOwner (myid) < ATTACK_SIGHT and ReturnEscapetoOwner == false) then

		local mobx,moby = GetV(V_POSITION, result)
		local myx,myy =GetV(V_POSITION, myid)
		
		if (mobx < myx) then
			if (moby < myy) then
				Move(myid,myx + 3,myy - 3)
				return
			else
				Move(myid,myx - 3,myy - 3)
				return
			end
		else
			if (moby < myy) then
				Move(myid,myx + 3,myy + 3)
				return
			else
				Move(myid,myx - 3,myy + 3)
				return
			end
		end
	else
		if(GetDistanceFromOwner (myid) < 3 or min_dis < 4) then
			ReturnEscapetoOwner = false
			return
		end
		ReturnEscapetoOwner = true
		local ownerx,ownery = GetV(V_POSITION, GetV(V_OWNER,myid))
		Move(myid,ownerx,ownery)
		return
	end
end
--------------------------------------------------------------------------------



--------------------------------------------------------------------------------
-- SetSleepTimer X[v^C}[nowԂŃZbg
function SetSleepTimer (now)
	Exit_Time_Stamp = now
end
--------------------------------------------------------------------------------
-- ExitAI() Q΍֐
function ExitAI(owner)
	local ox,oy = GetV(V_POSITION,owner)
	if(Motion_Stamp ~= GetV(V_MOTION,owner) or Position_StampX ~= ox or Position_StampY ~= oy)then
		Motion_Stamp = GetV(V_MOTION,owner)
		Position_StampX = ox
		Position_StampY = oy
		SetSleepTimer(os.time())
	elseif (os.time() - Exit_Time_Stamp >= EXIT_TIME) then
		os.exit()
	end
end
--------------------------------------------------------------------------------

